#ifndef _THREADED_CAM
#define _THREADED_CAM

#include "ofMain.h"
#include "aeroTAPCamera.h"
#include "aeroTAPLinuxCamera.h"

#define _MAX_CAMERA 1

#define LINUX

#ifdef LINUX
#define BI_RGB 0
typedef unsigned short WORD;
typedef unsigned int DWORD;
typedef long LONG;
typedef struct tagBITMAPINFOHEADER {
	DWORD biSize;
	LONG  biWidth;
	LONG  biHeight;
	WORD  biPlanes;
	WORD  biBitCount;
	DWORD biCompression;
	DWORD biSizeImage;
	LONG  biXPelsPerMeter;
	LONG  biYPelsPerMeter;
	DWORD biClrUsed;
	DWORD biClrImportant;
} BITMAPINFOHEADER, *PBITMAPINFOHEADER; 
typedef struct tagRECT {
	LONG left;
	LONG top;
	LONG right;
	LONG bottom;
} RECT;

#endif

class threadedCam : public ofThread{
public:

    string deviceName;
    int camWidth;
    int camHeight;
    int depthWidth;
    int depthHeight;
	int camFPS;
	int interval;
//	HWND m_hWnd;
	int m_nFrame;
	bool bNewFrame[_MAX_CAMERA];
	bool m_bStereo;
	int m_nCamNo;
	bool bRunning[2];
	BITMAPINFOHEADER *m_pInfoHeader[_MAX_CAMERA][6];
	int zdTable[_MAX_CAMERA][4096];
	int nTableLen[_MAX_CAMERA];
	threadedCam();
	virtual ~threadedCam();
	int getType();

//	void threadedCam::release();
	bool isFrameNew(int cam);
    bool start(int no,bool bMode);
    void stop(int nCamNo);
    void reset();
	int setIR(int nVal);

	unsigned char *getImage(int cam);
	unsigned char *getDepth(int cam);
	int loadZDTable(int cam);
	int GetActualFPS(int cam);
	void setDepthMax(int max);
	void setLog(bool b);
	int m_nMaxDepth;
	void SetFocalLength(float w, float h);
//	void GetFocalLength(float &w, float &h);

	bool bUSB2;
	float nFocalLengthW, nFocalLengthH;

	int nDepthHist[_MAX_CAMERA][120];
	int nDepthHistMin[_MAX_CAMERA];
	int nDepthHistMax[_MAX_CAMERA];
	int nDepthHistCut[_MAX_CAMERA];
	int nDepthHistCnt[_MAX_CAMERA];

private:
    string path;
	RECT m_rectView;
	bool bLog;

    ofVideoGrabber vidGrabber;
    ofImage exportImage;
    void threadedFunction();
	int nPType;

#define _LOG 4
	WORD *g_DepthLog[_MAX_CAMERA];
	int *g_DepthSum[_MAX_CAMERA];
	int g_nLogIndex[_MAX_CAMERA];
	unsigned char *g_nLogCnt[_MAX_CAMERA];
};

#endif
